
// bibhtml: Generates HTML page (with images) from BibTex files
// See: https://www.telecom-paris.fr/~elc/software/
//
// Copyright 2020 Eric Lecolinet (eric.lecolinet@gmail.com)
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef __Extension__
#define __Extension__

class Bib;
class BibEntry;


/** Extension.
 *  Manages non standard fields that require specific processing.
 */
class BibExtension {
public:
  BibExtension(Bib&);
  
  /// function that completes the entry.
  virtual void completeEntry(Bib&, BibEntry&) = 0;
};


/** Example of an Extension.
 */
class TelecomExtension : public BibExtension {
public:
  TelecomExtension(Bib&);
  void completeEntry(Bib&, BibEntry&) override;
};

#endif
